# RSUITE

[![npm](https://badge.fury.io/js/rsuite.svg)](https://www.npmjs.com/package/rsuite)
[![Travis](https://travis-ci.org/rsuite/rsuite.svg?branch=master)](https://travis-ci.org/rsuite/rsuite)
[![Coverage Status](https://coveralls.io/repos/github/rsuite/rsuite/badge.svg?branch=next)](https://coveralls.io/github/rsuite/rsuite?branch=next)

[![Discord](https://img.shields.io/badge/Discord-Join%20chat%20%E2%86%92-738bd7.svg)](https://discord.gg/GmPXTH3)


[<img src="https://opencollective.com/rsuite/tiers/backer.svg?avatarHeight=36">](https://opencollective.com/rsuite)


[<img src="https://user-images.githubusercontent.com/1203827/39026518-277950c4-4480-11e8-8109-42fbb0f2f7b5.png" width="100" />](https://rsuitejs.com)



RSUITE (React Suite) is a set of react component libraries for enterprise system products. Built by Hypers front-end team and UX team, mainly serve the company's large data products.

After three major revisions, a large number of components and rich functionality have been accumulated.




## Supported Browsers

| IE   | Edge | Firefox | Chrome | Safari |
| ---- | ---- | ------- | ------ | ------ |
| >=10 | >=14 | >= 45   | >= 49  | >= 10  |

The IE9 version (including IE9) is not supported at the beginning of Rsuite 3, and is supported by other modern PC browsers. is not recommended for use on the mobile browsers.

## UI Design

Rsuite Design Prototype and specification, click to [view](https://next.rsuitejs.com/design/index.html)

## Install

Rsuite is available as an [npm package](https://www.npmjs.com/package/rsuite).

```bash
npm i rsuite --save
```

## Usage

Here's a simple example

```js
import { Button } from 'rsuite';

import '~rsuite/lib/less/index.less';

ReactDOM.render(<Button>Button</Button>, mountNode);
```

To preview This example, click ['CodeSandbox'](https://codesandbox.io/s/mo7jxvr9x9?from-embed).

### Help Links

* [Quick start](https://next.rsuitejs.com/guide/usage)
* [Customizing themes](https://next.rsuitejs.com/guide/themes)
* [Internationalization](https://next.rsuitejs.com/guide/intl)
* [Components](https://next.rsuitejs.com/components/overview)

## Change Log

[Change Log](https://github.com/rsuite/rsuite/releases)

# Contributing

Please read through our [contributing guidelines](https://github.com/rsuite/rsuite/blob/next/CONTRIBUTING.md).

Editor preferences are available in the [.prettierrc](https://github.com/rsuite/rsuite/wiki/.prettierrc) for easy use in common text editors. Read more and download plugins at https://prettier.io/.

## License

[MIT license](https://github.com/rsuite/rsuite/blob/master/LICENSE)
